﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections;

namespace CustomSorting
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
            List<Item> items = new List<Item>();
            for (int i = 30; i >0; i--)
            {
                items.Add(new Item() { Value = i.ToString() });
            }

            items.Add(new Item() { Value = null });

            this.RadGridView1.ItemsSource = items;
            this.RadGridView1.Sorting += new EventHandler<Telerik.Windows.Controls.GridViewSortingEventArgs>(RadGridView1_Sorting);
        }

        void RadGridView1_Sorting(object sender, Telerik.Windows.Controls.GridViewSortingEventArgs e)
        {
            e.Cancel = true;//cancel the built in sorting so we can perform our custom logic instead

            this.PerformCustomStringSort();
        }
         
        private void PerformCustomStringSort()
        {
            var sorted = from i in this.RadGridView1.ItemsSource as List<Item>
                         orderby  i.Value==null?0:int.Parse(i.Value) ascending
                         select i;

            this.RadGridView1.ItemsSource = sorted.ToList();
        }

       
    }

    public class Item
    {
        public string Value { get; set; }
    }
}
